// Tabulka logaritmu

#include <iomanip>
#include <iostream>
#include <cmath>
using namespace std;
const n = 20;                          // Pocet cisel
const sloupcu = 4;                     // Pocet sloupcu
int main()
{
   double x;
   for(int i = 0; i < sloupcu; i++)    // Zahlavi tabulky
      cout << setw(5) << "x" << setw(10) << "log(x)";
   cout << endl;
      // Podtrzeni
   for(int i = 0; i < 15*sloupcu; i++) cout << "-";
   cout << endl;
      // Format pro tisk logaritmu
   cout << setprecision(6) 
        << setiosflags(ios::fixed | ios::showpoint) ;
   for(int i = 1; i < n+1; i++)
   {  // Vlastni tisk logaritmu
      cout << setw(5) << i << setw(10) << log((double)i);
      if((i%sloupcu) == 0) cout << endl;
   }
   return 0;
}
