template <class T>
class AutoUk
{
	T* p;
public:
	AutoUk(T* u = 0): p(u) {}
	AutoUk(AutoUk& au);	// Kopirovaci konstruktor
	AutoUk& operator=(AutoUk& au);	// Prirazovani instanci
	~AutoUk(){delete p; }	// Destruktor uvolni pamet
	T& operator*() const { return *p; }	// Operatory, jez zpristupni
	T* operator ->() const { return p; }// data
	AutoUk& operator=(T* pT){ delete p; p = pT; return *this;}
};
template<class T>						// Kopirovaci konstruktor
AutoUk<T>::AutoUk(AutoUk<T>& au)
{
	p = au.p;
	au.p = 0;
}
template<class T>						// Prirazovaci operator
AutoUk<T>& AutoUk<T>::operator=(AutoUk<T>& au)
{
	delete p;								// Nejprve znici instanci,
	p = au.p;								// na niz ukazoval puvodne,
	au.p = 0;								// pak prijme novou a 
	return *this;						// odebere ji puvodnimu
}													// majiteli

int main()
{
	AutoUk<int> u = new int();
	AutoUk<int> uu;
	uu = u;
}