#include <deque>
#include <iostream>
#include <algorithm>
#include <iterator>
using namespace std;

template<typename T, typename Kontejner = deque<T> >
class Stack
{
public:
	Stack(){kont = new Kontejner;}
	Stack(const Stack& s);
	template<typename U, typename KontejnerU>
		Stack(Stack<U, KontejnerU>& s);
	~Stack(){delete kont;}

	void push(T co) {kont->push_back(co);}
	T top(){return kont->back();}
	void pop(){kont->pop_back();}
	bool empty() {return kont->empty();}
	Stack& operator=(Stack<T, Kontejner>& s);
	template<typename U, typename KontejnerU>
		Stack& operator=(Stack<U, KontejnerU>& s);
	//template<typename T1, typename T2> friend class Stack;

	// a dalsi deklarace...
private:
	Kontejner *kont;
};

template<typename T, typename KontejnerT>
template<typename U, typename KontejnerU>
Stack<T, KontejnerT>::Stack(Stack<U, KontejnerU>& s)
{
	kont = new KontejnerT;
	Stack<U, KontejnerU> kopie(s);
	while(!kopie.empty())
	{
		kont->push_front(kopie.top());
		kopie.pop();
	}
}

template<typename T, typename KontejnerT>
template<typename U, typename KontejnerU>
Stack<T, KontejnerT>& Stack<T, KontejnerT>::operator=(Stack<U, KontejnerU>& s)
{
	kont->clear();
	Stack<U, KontejnerU> kopie(s);
	while(!kopie.empty())
	{
		kont->push_front(kopie.top());
		kopie.pop();
	}

	return *this;
}

template<typename T, typename Kontejner>
Stack<T, Kontejner>& Stack<T, Kontejner>::operator=(Stack<T, Kontejner>& s)
{
	kont->clear();
	copy(s.kont->begin(), s.kont->end(), back_inserter(*kont));
	return *this;
}

template<typename T, typename Kontejner>
Stack<T, Kontejner>::Stack(Stack<T, Kontejner> const& s)
{
	kont = new Kontejner;
	copy(s.kont->begin(), s.kont->end(), back_inserter(*kont));
}

int main()
{
	Stack<char> s;
	s.push('A');
	s.push('B');
	Stack<char> sc(s);
	Stack<double> sd(s);
	Stack<int> si, sj;
	si = s;
	sj = si;
}