// Sablona polymorfniho seznamu
// jen s nejnutnejsimi metodami, 
// aby priklad fungoval


template<typename T>
class seznam
{
public:
	struct prvek;

	seznam();
	virtual ~seznam();
	virtual void vyprazdni();
	virtual void vloz(T data_);
	virtual void vlozPole(T *data_, int kolik);
private:
	prvek *hlava, *zarazka;
};

template<typename T>
struct seznam<T>::prvek
{
	T data;
	prvek* dalsi;
	prvek(T data_=0, prvek* dalsi_=0)
		: data(data_), dalsi(dalsi_){}
};

// Konstruktor
template<typename T>
seznam<T>::seznam()
: hlava(0), zarazka(0)
{
	hlava = new prvek;
	zarazka = hlava;
}

template<typename T>
seznam<T>::~seznam()
{
	vyprazdni();
	delete zarazka;
}


template<typename T>
void seznam<T>::vyprazdni()
{
	prvek* p = hlava;
	while(p != zarazka)
	{
		hlava = hlava->dalsi;
		delete p;
		p = hlava;
	}
}

template<typename T>
void seznam<T>::vloz(T co)
{
	hlava = new prvek(co, hlava);
}

template<typename T>
void seznam<T>::vlozPole(T *co, int kolik)
{
	for(T* i = co; i < co+kolik; i++)
		vloz(*i);
}