#include <cstring>
#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

class String
{
	char *c;
	int delka;
public: 
	String(char* cc);
	String(const String& s);
	~String(){delete[] c;}
	char& operator[](int i){return c[i];}
	friend ostream& operator<<(ostream& P, String& s)
	{
		return P << s.c;
	}
	String& operator=(const String& s);
};

String::String(char* cc)
: c(0), delka(0)
{
	int n = strlen(cc)+1;
	c = new char[n];
	strcpy(c, cc);
	delka = n;
}

String::String(const String& s)
: c(0), delka(0)
{
	c = new char[s.delka];
	strcpy(c, s.c);
	delka = s.delka;
}

String& String::operator=(const String& s)
{
	char*p = new char[s.delka];              // Muze vyvolat vyjimku
	strcpy(p, s.c);                          // proto nejprve vytvorime kopii
	delete[] c;
	c = p;
	return *this; 
}

int main()
{
	vector<String> vs;
	String s1("Kocka leze dirou");
	String s2("Pes oknem");
	vs.push_back(s1);
	vs.push_back(s2);
	s1[0] = 'k';
	cout << vs[0]<< endl;
}
