// Skladani misto dedeni
// Zasobnik obsahuje seznam
#include <iostream>
#include <list>
using namespace std;

template<typename T>
class MujZasobnik
{
	list<T> kontejner;
public:
	MujZasobnik(){}
	void push(T x){kontejner.push_back(x);}
	T top(){return kontejner.back();}
	void pop(){kontejner.pop_back();}
	int size() {return kontejner.size();}
	bool empty() {return kontejner.empty();}
};


int main()
{
	MujZasobnik<int> z;
	z.push(10);
	z.push(5);
	int i = z.top();
	z.pop();
	i = z.top();
}