// Filtr pro konverzi Cp1250 -> Cp852
// Program konver.cpp 

#include <iostream>
#include <locale>
#include <string>
#include <stdexcept>

using namespace std;


int main(int argv, char *argc[])
{
	wstring ws;
	try {
		locale L1("Czech_Czech Republic.1250");
		locale L2("Czech_Czech Republic.852");
		wcin.imbue(L1);
		wcout.imbue(L2);
		while (getline(wcin, ws))
		{
			wcout << ws << endl;
			if(!wcout) wcerr << L"sorry" ;
		}
	}
	catch(runtime_error &e)
	{
		cerr << "Nepodporovane kodovani";
	}
	return 0;
}
