#include <locale>   
#include <iterator>
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>

using namespace std;

wstring x[]={L"Ackermann", L"Aden", L"Acheron", L"ackermann", L"Zidane"};
int n = 5;

void vystup(vector<wstring>& vs)   // Vpis na konzolu
{
   copy(vs.begin(), vs.end(), 
ostream_iterator<wstring, wchar_t>(wcout, L"\n"));
}

int main()
{
   locale LCz("Czech_Czech Republic.852");
   locale LS("Spanish_Spain.850");
   locale LE("English_United States.850");
   locale LC("C");
   locale *loc[]={&LC, &LCz, &LE, &LS};
   vector<wstring> v(x, &x[n]);
   vystup(v);            // Vypeme zadn
   for(int i = 0; i < sizeof(loc)/sizeof(locale*); i++)
   {
		wcout.imbue(*loc[i]);         // Nastav lokln zvyklosti
		wcout << L"-------" << endl;
		cout << loc[i]->name() << endl;
		wcout << L"-------" << endl;
		sort(v.begin(), v.end(), *loc[i]);   // Seadme prvky vektoru
		vystup(v);            // Vypeme seazen vektor
   }
   return 0;
}
