// Naivni implementace itoa()
// nefunguje pro INT_MIN

#include <iostream>
#include <limits>
using namespace std;

void PrepisObracene(char *c, char *e)  // Pomocna funkce
{                                      // Otoci retezec na miste
   while(c < e)                        // Ocekava ukazatel na prvni
   {                                   // a posledni platny znak 
      char z = *c;                     // otaceneho useku 
      *c++ = *e;
      *e-- = z;
   }
}
char* itoa(int n, char C[])
{
   int sgn = 0;
   char *c = C;
   if(n<0)           // Je-li n < 0, zapamatuj si to a pokracuj
   {                 // s absolutni hodnotou n
      sgn = -1;
      n = -n;
   }
   if(n == 0) *c++ = '0';  // Nulu osetrime zvlast
   else   
   {
      while(n)       // Tento cyklus zapise do pole C znakovou
      {              // podobu n, ale obracene
         *c++ = "0123456789"[n%10];
         n /= 10;
      }              // Pro zaporna cisla pridame minus
      if(sgn) *c++ = '-';
      *c-- = 0;      // Nula ukoncujici retezec
      PrepisObracene(C, c);   // Prepis retezec normalne
   }
   return C;
}


int main()
{
	char c[100];
	cout << itoa(123,c) << endl;
	cout << itoa(numeric_limits<int>::min(), c); // Nefunguje
}