// Implementace itoa() , ktera si poradi i s INT_MIN

#include <iostream>
#include <limits>
using namespace std;

void PrepisObracene(char *c, char *e)  // Pomocna funkce
{                                      // Otoci retezec na miste
   while(c < e)                        // Ocekava ukazatel na prvni
   {                                   // a posledni platny znak 
      char z = *c;                     // otaceneho useku 
      *c++ = *e;
      *e-- = z;
   }
}
char* itoa(int n, char C[])
{
   int sgn = -1;
   char *c = C;
   if(n>0)                   // Kladna cisla prevedeme na zaporna
   {                         // a zapamatujeme si puvodni znamenko
      sgn = 0;
      n = -n;
   }
   if(n == 0) *c++ = '0';    // Nulu osetrime zvlast
   else
   {
      while(n)
      {               // Zbytek po deleni zaporneho cisla kladnym
         *c++ = "0123456789"[-(n%10)];   // je zaporny (?)
         n /= 10;
      }
      if(sgn) *c++ = '-';    // Doplnime znamenko
      *c-- = 0;
      PrepisObracene(C, c);  // a prepiseme 
   }
   return C;
}


int main()
{
	char c[100];
	cout << itoa(123,c) << endl;
	cout << itoa(numeric_limits<int>::min(), c); // Nefunguje
}