#include <cstring>		// Pro retezce ukoncene nulou
#include <algorithm>
#include <iostream>
using namespace std;



class String {
	unsigned len;		// Delka retezce
	char *s;			// Ukazatel na pole znaku
public:
	static String concat(const String &, const String &);
	String(const char *);
	String(const String &);
	~String(){ cout <<"destruktor" << s << endl; delete s; }
	operator char*() { return s; }	// !!?
	//operator void*() {return s; } // Odstrani moznost pouzit delete na instanci
	String operator+(const String& t)
	{
		return concat(*this, t); 
	}
	String& operator=(const String& x);
};

String& String::operator=(const String& x)
{
	char *p = new char[x.len+1];
	strcpy(p, x.s);
	swap(p, s);
	len = x.len;
	delete p;
	return *this;
}

String::String(const char *t="")
: len(0), s(0)
{
	cout <<"konstruktor" << t << endl;
	if(t)
	{
		len = strlen(t);
		s = new char[len+1];
		strcpy(s, t);
	}
}

String::String(const String& x)
: len(0), s(0)
{
	cout <<"k-konstruktor" << x.s << endl;
	s = new char[x.len+1];
	strcpy(s, x.s);
	len = x.len;
}

String String::concat(const String &a, const String &b)
{
	char *p = new char[a.len+b.len+1];
	strcpy(p, a.s);
	strcpy(p+a.len, b.s);
	String x(p);
	delete p;
	return x;
}

String a("ahoj");
String b("lidi");
char* uString=0;

void F()
{
	cout << a+b<< endl;
}

int main()
{
	char *p = uString;
	F();
	cout << uString<< endl;
	p = uString;
	String c("");
	//c = a+b;
	c=a;
	p = a;
	p[1] = 65;
	
}