#include <iostream>
#include <new>
#include <string>
#include <iostream>
using namespace std;

void denik(char* s)
{
	cout << s << endl;
}
// barvy pro kresleni grafickych objektu a jejich nazvy
enum Barva {cerna, bila, zelena, modra, cervena};
char *BARVA[] = {"cerna", "bila", "zelena", "modra", "cervena"};

class GO								// Spolecny predek vsech grafickych objektu
{
protected:
   int barva;
public:
   GO(int barva=0): barva(barva) {}
   void Zobraz() const;
   void Smaz() const;
   virtual void Nakresli(int _barva) const;
   void* operator new(size_t s);
   void operator delete(void* p);
   //virtual 
	   ~GO(){cout << "dgo"<< endl;}
};

void* GO::operator new(size_t s)
{
	denik("alokace GO");
	return ::operator new(s);
}

void GO::operator delete(void *p)
{
	denik("uvolneni GO");
	::operator delete(p);
}

void GO::Zobraz() const
{
   Nakresli(barva);
}
void GO::Smaz() const
{
   Nakresli(cerna);
}
void GO::Nakresli(int _barva) const
{
   cout << "GO, barva " << BARVA[_barva] << endl;
}
class bod: public GO
{
protected:
   int x, y;
public:
   bod(int x, int y, int barva): GO(barva), x(x), y(y) {}
   void Nakresli(int _barva) const;
   void* operator new(size_t s);
   void operator delete(void* p);

   ~bod(){cout << "db" << endl;}
};

void* bod::operator new(size_t s)
{
	denik("alokace bodu");
	return ::operator new(s);
}

void bod::operator delete(void *p)
{
	denik("uvolneni bodu");
	::operator delete(p);
}


void bod::Nakresli(int _barva) const
{
   cout	<< "bod, barva " << BARVA[_barva] << ", souradnice " 
   << x << ", " << y << endl;
}
class usecka: public GO { 
bod A, B;
public:
   usecka(int x1, int y1, int x2, int y2, int barva)
   : GO(barva), A(x1, y1, barva), B(x2, y2, barva)
   {}
   void Nakresli(int _barva) const;
};

void usecka::Nakresli(int _barva)const 
{
   cout << "usecka, barva " << BARVA[_barva] << ", pocatek a konec: "; 
   A.Nakresli(_barva);
   B.Nakresli(_barva);
}

int main()
{
  	GO* g = new bod(3,4,1);
	delete g;
	return 0;
}