#include <string>
#include <list>
using namespace std;
typedef int udaj;

class Obraz                            // Obrazek houby
{
public:
	Obraz(const string& JmenoSouboruSObrazkem){}
   // ... a dalsi slozky
};
class Text                            // Popis houby
{
public:
	Text(const string& JmenoSouboruSPopisem){}
};
class Vyskyt
{
   list<udaj> data;
public:
	Vyskyt(const string& JmenoSouboruSDaty){}
   // ... a dalsi slozky
};

class Houba
{
   string ceske_jmeno;
   string latinske_jmeno;
   Text * popis;
   Obraz * obrazek;
   Vyskyt * vyskyt;
public:
   Houba(const string& ces_jm, const string& lat_jm = "",
         const string& jmeno_obr = "", 
         const string& jmeno_pop = "",
         const string& jmeno_dat = "");
   ~Houba();
   // a dalsi slozky a metody
};

Houba::Houba(const string& ces_jm, const string& lat_jm,
      const string& jmeno_obr, 
      const string& jmeno_pop,
      const string& jmeno_dat)
: ceske_jmeno(ces_jm), latinske_jmeno(lat_jm),
  popis(0), obrazek(0), vyskyt(0)
{
   try
   {
      if(jmeno_obr != "")
         obrazek = new Obraz(jmeno_obr);
      if(jmeno_pop != "")
         popis = new Text(jmeno_pop);
      if(jmeno_dat != "")
         vyskyt = new Vyskyt(jmeno_dat);
   }
   catch(...)
   {
      delete popis;
      delete obrazek;
      delete vyskyt;
      throw;
   }
}

int main()
{
}