#include <string>
#include <iostream>
#include <exception>
using namespace std;
double Zpracuj(double d){ return d;}
class Chyba: public exception						// Trida pro prenos informaci o vyjimce
{		
	string text;					// Obsahuje retezec s popisem chyby
public:
	Chyba(char * c):text(c){};
	void pripoj(char *c){ text.append(c);}
	virtual void CoJe() { cout << text << endl;}
};
double Sqrt(double x) 	// Vypocet odmocniny, pro x<0 vyvola vyjimku
{
	if(x < 0) throw Chyba("Odmocnina ze zaporneho cisla");
	// ...
}
double F(double x)			// Vyuziva funkce Sqrt(), ale neumi osetrit
{											// vyjimku, je-li parametr x zaporny
	double r;
	try
	{
		r = Sqrt(x);
	}
	catch(Chyba& Ch)			// Je-li x < 0, zachytime vzviklou vyjimku
	{										// a dale posleme upravenou informaci
		Ch.pripoj(" ve funkci F");
		throw;
	}
	return Zpracuj(r);		// Je-li vse OK, zpracujeme odmocninu 
}											// a vysledek vratime

int main()
{
	try{
		F(-1);
	}
	catch(Chyba ch)
	{
		ch.CoJe();
	}
}