#include <iostream>
using namespace std;

template<typename T> class Cislo;

long double Plus(Cislo<int>, int);

template<typename T>
long double Plus(Cislo<T>, long double);

template<typename T>
class Cislo
{
	T x;
public:
	Cislo(T y): x(y){}
	template<typename U> operator U(){return x;}
	
	// Deklarace nove funkce
	friend long double Plus(Cislo<T> X, char z){return z+X.x;}

	// Odkaz na obycejnou funkci deklarovanou vyse
	friend long double ::Plus(Cislo<int>, int);

	// Odkaz na instanci sablony
	friend long double ::Plus<double>(Cislo<double>, long double);
};

long double Plus(Cislo<int> X, int d)
{
	return d + X.x;
}

template<typename T>
long double Plus(Cislo<T> X, long double d)
{
	return d + X.x;
}

int main()
{
	Cislo<int> a(5);
    int n = Plus(a, 's');
	n = Plus(a, 6);
	n = Plus<double>(a, 2.2);
}