// Podle vnorene sablony se nevytvori kopirocavi konstruktor
// ani kopirovaci prirazovaci operator 

#include <deque>
#include <iostream>
using namespace std;

template<typename T, typename Kontejner = deque<T> >
class Stack
{
public:
	typedef typename Kontejner::iterator iterator;
	
	Stack(){kont = new Kontejner;}
	template<typename U, typename KontejnerU>
		Stack(Stack<U, KontejnerU>& s);

	void push(T co) {kont->push_back(co);}
	T top(){return kont->back();}
	void pop(){kont->pop_back();}
	iterator begin() {return kont->begin();}
	iterator end() {return kont->end();}
	template<typename U, typename KontejnerU>
		Stack& operator=(Stack<U, KontejnerU>& s);

	// a dalsi deklarace...
private:
	Kontejner *kont;
	template<typename U, typename KontejnerU>
		void nakopiruj(Stack<U, KontejnerU>& s);
};

template<typename T, typename KontejnerT>
template<typename U, typename KontejnerU>
void Stack<T, KontejnerT>::nakopiruj(Stack<U, KontejnerU>& s)
{
	for(Stack<U, KontejnerU>::iterator I = s.begin(); I != s.end(); ++I)
		push(*I);
}

template<typename T, typename KontejnerT>
template<typename U, typename KontejnerU>
Stack<T, KontejnerT>::Stack(Stack<U, KontejnerU>& s)
{
	kont = new KontejnerT;
	nakopiruj(s);
}

template<typename T, typename KontejnerT>
template<typename U, typename KontejnerU>
Stack<T, KontejnerT>& Stack<T, KontejnerT>::operator=(Stack<U, KontejnerU>& s)
{
	kont->clear();
	nakopiruj(s);
	return *this;
}


int main()
{
	Stack<char> s;
	s.push('A');
	s.push('B');
	Stack<char> sc(s);	// !!!
    	for(Stack<char>::iterator i = s.begin(); i != s.end(); i++)
		cout << *i << endl;
	Stack<double> sd(s);
	for(Stack<double>::iterator i = sd.begin(); i != sd.end(); i++)
		cout << *i << endl;
	Stack<int> si, sj;
	si = s;
	sj = si;	// !!!
	for(Stack<double>::iterator i = sd.begin(); i != sd.end(); i++)
		cout << *i << endl;
}