// Opravena implementace tridy PocitanySeznam
// Trida je primm potomkem AbstraktnihoSeznamu
// a seznam pouziva jen jako datovou slozku

#include "seznam.h"

template<typename T>
class pocitanySeznam: public AbstraktniSeznam<T>
{
	unsigned velikost_;
	seznam<T> S;
public:
	pocitanySeznam(): velikost_(0){}
	void vloz(T co){S.vloz(co); velikost_++;}
	void vlozPole(T *co, int kolik){
		S.vlozPole(co, kolik); 
		velikost_+=kolik;
	}
	void vyprazdni(){S.vyprazdni(); velikost_= 0;}
	unsigned velikost() {return velikost_;} 
};